Subject: Re: randconfig build error with next-20150908, in drivers/md/dm-mpath.c

From: Hannes Reinecke <[email-masked]>
Date: Sun, 13 Sep 2015 16:29:38 +0200

On 09/08/2015 08:30 PM, Mike Snitzer wrote:
> On Tue, Sep 08 2015 at  1:34pm -0400,
> James Bottomley <[email-masked]> wrote:
> 
>> On Tue, 2015-09-08 at 13:23 -0400, Mike Snitzer wrote:
>>> On Tue, Sep 08 2015 at  1:10pm -0400,
>>> Jim Davis <[email-masked]> wrote:
>>>
>>>> Building with the attached random configuration file,
>>>>
>>>> drivers/built-in.o: In function `activate_path':
>>>> /home/jim/linux-next/drivers/md/dm-mpath.c:1225: undefined reference
>>>> to `scsi_dh_activate'
>>>> drivers/built-in.o: In function `parse_path':
>>>> /home/jim/linux-next/drivers/md/dm-mpath.c:581: undefined reference to
>>>> `scsi_dh_attached_handler_name'
>>>> /home/jim/linux-next/drivers/md/dm-mpath.c:600: undefined reference to
>>>> `scsi_dh_attach'
>>>> /home/jim/linux-next/drivers/md/dm-mpath.c:615: undefined reference to
>>>> `scsi_dh_set_params'
>>>
>>> These DM-mpath changes were staged via linux-scsi.  Cc'ing James and Christoph.
>>
>> [adding linux-scsi]
>>
>> It must be Hannes' dm changes ... you acked them.  I take it the problem
>> is now dm-mpath won't build without CONFIG_SCSI?  How do you want it
>> fixed?  We can either add a Kconfig dependency or try to disentangle
>> them again.
> 
> OK (Hannes' changes).  I'm fine with seeing DM_MULTIPATH depend on
> CONFIG_SCSI.
> 
Indeed, with the switch for having scsi_dh being moved into struct
scsi_device DM_MULTIPATH will now depend on SCSI.

> The Kconfig for DM_MULTIPATH is clearly stale:
> 
>         # nasty syntax but means make DM_MULTIPATH independent
>         # of SCSI_DH if the latter isn't defined but if
>         # it is, DM_MULTIPATH must depend on it.  We get a build
>         # error if SCSI_DH=m and DM_MULTIPATH=y
>         depends on SCSI_DH || !SCSI_DH
> 
> James, if you have a vision for how to fix this please feel free.
> Otherwise, Hannes, care to send a patch to fix this?
> 
Yep, once I'm back in the office on Monday.

Cheers,

Hannes
-- 
Dr. Hannes Reinecke		      zSeries & Storage
[email-masked]			      +49 911 74053 688
SUSE LINUX Products GmbH, Maxfeldstr. 5, 90409 Nürnberg
GF: J. Hawn, J. Guild, F. Imendörffer, HRB 16746 (AG Nürnberg)
--
To unsubscribe from this list: send the line "unsubscribe linux-scsi" in
the body of a message to [email-masked]
More majordomo info at  http://vger.kernel.org/majordomo-info.html